/* $Id: nit4read.c,v 1.2 89/07/11 03:07:47 dupuy Exp $ */

/*
 * Reads and returns a single packet, filling in all fields.  If pktbuf is
 * NULL, a buffer is allocated for it.	If pktbuf is not NULL, the function
 * assumes that pktbuf is large enough to hold the packet.  Since the stream
 * was placed in RMSGD mode, readv() gets one packet at a time, so ether_read()
 * returns one packet at a time.
 */

#include <errno.h>

#include <sys/types.h>
#include <sys/uio.h>

#include "libether.h"

#define HEADER	0
#define DATA	1

int
ether_read (fd, packet)
int fd;
ether_packet *packet;
{
    struct iovec iov[2];
    int count;

    iov[HEADER].iov_len = ETHER_PKT;
    iov[HEADER].iov_base = (char *) packet;

    if (packet->pktbuf)
    {
	iov[DATA].iov_len = packet->pktlen;
	iov[DATA].iov_base = packet->pktbuf;
    }
    else
    {
	iov[DATA].iov_len = packet->pktlen = ETHER_MAX;
	if ((iov[DATA].iov_base = malloc ((unsigned) ETHER_MAX)) == 0)
	    return (-1);
	 packet->pktbuf = iov[DATA].iov_base;
    }

    if ((count = readv (fd, iov, 2)) < 0)
	return (-1);

    if ((count -= ETHER_PKT) < 0)
	errno = EBADMSG;
    else
	if (packet->pktlen > count)
	    packet->pktlen = count;

    return (count);
}
