/* $Id: nitaddr.c,v 1.2 89/07/11 03:07:48 dupuy Exp $ */

/*
 * Returns the local ethernet address for the ethernet interface on the file
 * descriptor fd.  The result is stored in the structure given by address; if
 * none is given, malloc is used to allocate space.
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#ifdef _SOCKET_				/* 4.0 system? */
#include <sys/sockio.h>
#else
#endif
#include <sys/ioctl.h>

#include "libether.h"

ether_addr *ether_address(fd, address)
int fd;
ether_addr *address;
{
    struct ifreq ifr;

    ifr.ifr_addr.sa_family = AF_NIT;
    if (ioctl (fd, SIOCGIFADDR, &ifr) < 0)
    {
#ifdef DEBUG
	perror ("ether_addr: ioctl SIOCGIFADDR");
#endif
	return (0);
    }

    if (address == 0)
	address = (ether_addr *) malloc (sizeof (ether_addr));

    if (address != 0)
	bcopy (ifr.ifr_addr.sa_data, (char *) address, sizeof (ether_addr));

    return (address);
}
